"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0,require("reflect-metadata");var _typeorm=require("typeorm"),_crypto=require("crypto"),_errors=require("../../lib/errors"),_models=_interopRequireDefault(require("./models"));function _interopRequireDefault(a){return a&&a.__esModule?a:{default:a}}function asyncGeneratorStep(a,b,c,d,e,f,g){try{var h=a[f](g),i=h.value}catch(a){return void c(a)}h.done?b(i):Promise.resolve(i).then(d,e)}function _asyncToGenerator(a){return function(){var b=this,c=arguments;return new Promise(function(d,e){function f(a){asyncGeneratorStep(h,d,e,f,g,"next",a)}function g(a){asyncGeneratorStep(h,d,e,f,g,"throw",a)}var h=a.apply(b,c);f(void 0)})}}function ownKeys(a,b){var c=Object.keys(a);if(Object.getOwnPropertySymbols){var d=Object.getOwnPropertySymbols(a);b&&(d=d.filter(function(b){return Object.getOwnPropertyDescriptor(a,b).enumerable})),c.push.apply(c,d)}return c}function _objectSpread(a){for(var b,c=1;c<arguments.length;c++)b=null==arguments[c]?{}:arguments[c],c%2?ownKeys(Object(b),!0).forEach(function(c){_defineProperty(a,c,b[c])}):Object.getOwnPropertyDescriptors?Object.defineProperties(a,Object.getOwnPropertyDescriptors(b)):ownKeys(Object(b)).forEach(function(c){Object.defineProperty(a,c,Object.getOwnPropertyDescriptor(b,c))});return a}function _defineProperty(a,b,c){return b in a?Object.defineProperty(a,b,{value:c,enumerable:!0,configurable:!0,writable:!0}):a[b]=c,a}var Adapter=function(a){function b(){return c.apply(this,arguments)}function c(){return c=_asyncToGenerator(function*(b){function c(){return d.apply(this,arguments)}function d(){return d=_asyncToGenerator(function*(){n=(0,_typeorm.getConnection)(a.name),n.isConnected||(n=yield n.connect())}),d.apply(this,arguments)}function f(){if(b.debug){for(var a=arguments.length,c=Array(a),d=0;d<a;d++)c[d]=arguments[d];console.log("[DEBUG]",...c)}}function h(){return j.apply(this,arguments)}function j(){return j=_asyncToGenerator(function*(a){f("Create user",a);try{var b=new g(a.name,a.email,a.image);return yield(0,_typeorm.getManager)().save(b)}catch(a){return console.error("CREATE_USER_ERROR",a),Promise.reject(new _errors.CreateUserError(a))}}),j.apply(this,arguments)}function l(){return m.apply(this,arguments)}function m(){return m=_asyncToGenerator(function*(a){f("Get user",a);try{return n.getRepository(g).findOne({id:a})}catch(a){return console.error("GET_USER_BY_ID_ERROR",a),Promise.reject(new Error("GET_USER_BY_ID_ERROR",a))}}),m.apply(this,arguments)}function o(){return p.apply(this,arguments)}function p(){return p=_asyncToGenerator(function*(a){f("Get user by email address",a);try{return n.getRepository(g).findOne({email:a})}catch(a){return console.error("GET_USER_BY_EMAIL_ERROR",a),Promise.reject(new Error("GET_USER_BY_EMAIL_ERROR",a))}}),p.apply(this,arguments)}function q(){return r.apply(this,arguments)}function r(){return r=_asyncToGenerator(function*(a,b){f("Get user by provider account ID",a,b);try{var c=yield n.getRepository(e).findOne({providerId:a,providerAccountId:b});return c?n.getRepository(g).findOne({id:c.userId}):null}catch(a){return console.error("GET_USER_BY_PROVIDER_ACCOUNT_ID_ERROR",a),Promise.reject(new Error("GET_USER_BY_PROVIDER_ACCOUNT_ID_ERROR",a))}}),r.apply(this,arguments)}function s(){return t.apply(this,arguments)}function t(){return t=_asyncToGenerator(function*(a){return f("Get user by credentials",a),!1}),t.apply(this,arguments)}function u(){return v.apply(this,arguments)}function v(){return v=_asyncToGenerator(function*(a){return f("Update user",a),!1}),v.apply(this,arguments)}function w(){return x.apply(this,arguments)}function x(){return x=_asyncToGenerator(function*(a){return f("Delete user",a),!1}),x.apply(this,arguments)}function y(){return z.apply(this,arguments)}function z(){return z=_asyncToGenerator(function*(a,b,c,d,g,h,i){f("Link provider account",a,b,c,d,g,h,i);try{var j=new e(a,b,c,d,g,h,i);return(0,_typeorm.getManager)().save(j)}catch(a){return console.error("LINK_ACCOUNT_ERROR",a),Promise.reject(new Error("LINK_ACCOUNT_ERROR",a))}}),z.apply(this,arguments)}function A(){return B.apply(this,arguments)}function B(){return B=_asyncToGenerator(function*(a,b,c){return f("Unlink provider account",a,b,c),!1}),B.apply(this,arguments)}function C(){return D.apply(this,arguments)}function D(){return D=_asyncToGenerator(function*(a){f("Create session",a);try{var{sessionMaxAge:c}=b,d=null;if(c){var e=new Date;e.setTime(e.getTime()+c),d=e.toISOString()}var g=new i(a.id,null,d);return(0,_typeorm.getManager)().save(g)}catch(a){return console.error("CREATE_SESSION_ERROR",a),Promise.reject(new Error("CREATE_SESSION_ERROR",a))}}),D.apply(this,arguments)}function E(){return F.apply(this,arguments)}function F(){return F=_asyncToGenerator(function*(a){f("Get session",a);try{var b=yield n.getRepository(i).findOne({sessionToken:a});return b&&b.sessionExpires&&new Date>new Date(b.sessionExpires)?null:b}catch(a){return console.error("GET_SESSION_ERROR",a),Promise.reject(new Error("GET_SESSION_ERROR",a))}}),F.apply(this,arguments)}function G(){return H.apply(this,arguments)}function H(){return H=_asyncToGenerator(function*(a,c){f("Update session",a);try{var{sessionMaxAge:d,sessionUpdateAge:e}=b;if(d&&(e||0===e)&&a.sessionExpires){var g=new Date(a.sessionExpires);if(g.setTime(g.getTime()-d),g.setTime(g.getTime()+e),new Date>g){var h=new Date;h.setTime(h.getTime()+d),a.sessionExpires=h.toISOString()}else if(!c)return null}else if(!c)return null;return(0,_typeorm.getManager)().save(a)}catch(a){return console.error("UPDATE_SESSION_ERROR",a),Promise.reject(new Error("UPDATE_SESSION_ERROR",a))}}),H.apply(this,arguments)}function I(){return J.apply(this,arguments)}function J(){return J=_asyncToGenerator(function*(a){f("Delete session",a);try{return yield n.getRepository(i).delete({sessionToken:a})}catch(a){return console.error("DELETE_SESSION_ERROR",a),Promise.reject(new Error("DELETE_SESSION_ERROR",a))}}),J.apply(this,arguments)}function K(){return L.apply(this,arguments)}function L(){return L=_asyncToGenerator(function*(a,c,d,e,g){f("Create verification request",a);try{var{site:h,verificationMaxAge:i}=b,{verificationCallback:j}=g,l=(0,_crypto.createHash)("sha256").update("".concat(d).concat(e)).digest("hex"),m=null;if(i){var p=new Date;p.setTime(p.getTime()+i),m=p.toISOString()}var n=new k(a,l,m),o=yield(0,_typeorm.getManager)().save(n);return yield j({recipient:a,url:c,token:d,site:h,provider:g}),o}catch(a){return console.error("CREATE_EMAIL_VERIFICATION_ERROR",a),Promise.reject(new Error("CREATE_EMAIL_VERIFICATION_ERROR",a))}}),L.apply(this,arguments)}function M(){return N.apply(this,arguments)}function N(){return N=_asyncToGenerator(function*(a,b,c){f("Get verification request",a,b);try{var d=(0,_crypto.createHash)("sha256").update("".concat(b).concat(c)).digest("hex"),e=yield n.getRepository(k).findOne({email:a,token:d});return e&&e.expires&&new Date>new Date(e.expires)?(yield n.getRepository(k).delete({token:d}),null):e}catch(a){return console.error("GET_EMAIL_VERIFICATION_ERROR",a),Promise.reject(new Error("GET_EMAIL_VERIFICATION_ERROR",a))}}),N.apply(this,arguments)}function O(){return P.apply(this,arguments)}function P(){return P=_asyncToGenerator(function*(a,b,c){f("Delete verification request",a,b);try{var d=(0,_crypto.createHash)("sha256").update("".concat(b).concat(c)).digest("hex");yield n.getRepository(k).delete({token:d})}catch(a){return console.error("DELETE_EMAIL_VERIFICATION_ERROR",a),Promise.reject(new Error("DELETE_EMAIL_VERIFICATION_ERROR",a))}}),P.apply(this,arguments)}if(!n)try{n=yield(0,_typeorm.createConnection)(a)}catch(a){"AlreadyHasActiveConnectionError"===a.name?yield c():console.error("ADAPTER_CONNECTION_ERROR",a)}else yield c();return Promise.resolve({createUser:h,getUser:l,getUserByEmail:o,getUserByProviderAccountId:q,getUserByCredentials:s,updateUser:u,deleteUser:w,linkAccount:y,unlinkAccount:A,createSession:C,getSession:E,updateSession:G,deleteSession:I,createEmailVerification:K,getEmailVerification:M,deleteEmailVerification:O})}),c.apply(this,arguments)}var d=1<arguments.length&&arguments[1]!==void 0?arguments[1]:{},e=d.Account?d.Account.model:_models.default.Account.model,f=d.Account?d.Account.schema:_models.default.Account.schema,g=d.User?d.User.model:_models.default.User.model,h=d.User?d.User.schema:_models.default.User.schema,i=d.Session?d.Session.model:_models.default.Session.model,j=d.Session?d.Session.schema:_models.default.Session.schema,k=d.EmailVerification?d.EmailVerification.model:_models.default.EmailVerification.model,l=d.EmailVerification?d.EmailVerification.schema:_models.default.EmailVerification.schema,m={name:"default",autoLoadEntities:!0,entities:[new _typeorm.EntitySchema(f),new _typeorm.EntitySchema(h),new _typeorm.EntitySchema(j),new _typeorm.EntitySchema(l)],logging:!1};a=_objectSpread(_objectSpread({},m),a);var n=null;return{getAdapter:b}},_default={Adapter,Models:_models.default};exports.default=_default;